{$PACKRECORDS 1}
UNIT Cursors;
{$DEFINE CAN_OVERLAY}
{$I WEGLOBAL.PAS}

INTERFACE

TYPE
  CursorStates = (On, Off, FullBlock, BottomHalf, TopHalf, UnderScore);

PROCEDURE Cursor(State:CursorStates);
PROCEDURE PushCursor;
PROCEDURE PopCursor;

IMPLEMENTATION

USES ncurses;

CONST
  Init: Boolean = FALSE;

TYPE
   CsrStackPtr = ^CsrStack;
   CsrStack = RECORD
                state : word;
                next  : CsrStackPtr;
              END;
VAR
  CSR_START,CSR_END:byte;
  CSR_BOTTOM : byte;
  CursorStack:CsrStackPtr;
  LastSet:byte;

PROCEDURE InitCursor;
BEGIN
  CursorStack:=NIL;
  Init:=TRUE;
END;

PROCEDURE PushCursor;
VAR temp:CsrStackPtr;
BEGIN
  IF NOT Init THEN InitCursor;
  new(temp);
  temp^.next:=CursorStack;
  temp^.state:=LastSet;
  CursorStack:=temp;
END;

PROCEDURE PopCursor;
VAR temp:CsrStackPtr;
BEGIN
  curs_set(CursorStack^.state);
  temp:=CursorStack;
  CursorStack:=CursorStack^.next;
  dispose(temp);
END;


PROCEDURE Cursor(State:CursorStates);
BEGIN
  IF NOT Init THEN InitCursor;
  CASE State OF
    On        : BEGIN
				  LastSet:=1;
				  curs_set(1);
                END;
    Off       : BEGIN
				  LastSet:=0;
				  curs_set(0);
                END;
    FullBlock : BEGIN
				  LastSet:=2;
				  curs_set(2);
                END;
    Underscore: BEGIN
				  LastSet:=1;
				  curs_set(1);
                END;
    TopHalf   : BEGIN
				  LastSet:=2;
				  curs_set(2);
                END;
    BottomHalf: BEGIN
				  LastSet:=2;
				  curs_set(2);
                END;
  END;
END;

END.
