UNIT WEKbd;
{$I WEGLOBAL.PAS}
{ -- This is the Low Level Keyboard Module for WWIVEdit 2.3
  -- Last Modified : 4/15/92
  -- Written By:
  --   Adam Caldwell
  --
  -- This Code is Limited Public Domain (see WWIVEDIT.PAS for details)
  --
  -- Purpose : Provides low level, buffered keyboard input routines
  --
  -- Know Errors: Will lock up a computer if the user hangs up while
  --  seperate_local_input is on.  This only occurs during chat mode.
  --
  -- Planned Enhancements : Implementing fix described in WECHAT.PAS
  --
  -- }

INTERFACE


PROCEDURE Drain;
FUNCTION  ReadKey:char;
FUNCTION  KeyPressed:boolean;
FUNCTION  weEmpty:boolean;
PROCEDURE SeperateLocalInput;
PROCEDURE MergeLocalInput;
FUNCTION  KeyPressedL:boolean;
FUNCTION  ReadKeyL:char;
PROCEDURE StuffIn(s:string);
PROCEDURE Macro(ch:char);
{ PROCEDURE EnableInts; INLINE($FB);  }
{ PROCEDURE DisableInts; INLINE($FA); }

IMPLEMENTATION

Uses ncurses,NewCrt,wevars;

{------------------------------------------------------
 Check if a key has been pressed.
 Note: this is best used along with select() on STDIN,
 as it can suck up lots of cpu time.
 Better yet, use nKeypressed instead if you don't need
 to include file descriptors other than STDIN.
 ------------------------------------------------------}

function  Keypressed : boolean;
Begin
	Keypressed := newcrt.keypressed;
End;

PROCEDURE Drain;
var c : char;
begin
	while qKeyPressed do c:=readkey;
end;

{ silently read a key from stdscr }
Function Readkey : char;
Begin
   Readkey := NewCrt.Readkey;
End;

Function weEmpty : boolean;
begin
	weEmpty:=not Keypressed;
end;

PROCEDURE SeperateLocalInput;
begin
end;

PROCEDURE MergeLocalInput;
begin
end;

FUNCTION  KeyPressedL:boolean;
begin
	KeyPressedL:=Keypressed;
end;

FUNCTION  ReadKeyL:char;
begin
	ReadKeyL:=readkey;
end;

PROCEDURE StuffIn(s:string);
var i : integer;
begin
	for i:=length(s) downto 1 do
  		ungetch(ord(s[i]));
end;


PROCEDURE Macro(ch:char);
BEGIN
  IF (Setting.BBS=BBS_None) AND (Setting.WWIVEditMacrosOk)
  THEN CASE ch OF
    ^A : begin ungetch(0); ungetch(1); end;
    ^D : begin ungetch(0); ungetch(2); end;
    ^F : begin ungetch(0); ungetch(3); end;
  END
  ELSE IF (Setting.BBS=BBS_WWIV) THEN
  BEGIN
	ungetch(ord(^P));
    ungetch(ord(ch));
  END
END;

begin
end.
